Subject: bug#65250: closed (Re: bug#65250: 30.0.50; "C-h f" is much slower on the master branch)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 16 Aug 2023 14:53:02 +0000

Your bug report

#65250: 30.0.50; "C-h f" is much slower on the master branch

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
65250: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=65250
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#65250: 30.0.50; "C-h f" is much slower on the master branch
From: Eli Zaretskii <[email-masked]>
To: Andrea Corallo <[email-masked]>
Cc: [email-masked]
Date: Wed, 16 Aug 2023 17:52:03 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Andrea Corallo <[email-masked]>
> Cc: [email-masked]
> Date: Wed, 16 Aug 2023 09:55:19 -0400
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> Before installing it, even in non native builds, C-h f was showing the
> >> type for functions listed in `comp-known-type-specifiers'.
> >
> > How can I see this capability?
> 
> Should be sufficient say 'C-h f +'.

OK, works here in a build without native compilation.

So I think we can now close this bug.

Subject: 30.0.50; "C-h f" is much slower on the master branch
From: Eli Zaretskii <[email-masked]>
To: [email-masked]
Date: Sat, 12 Aug 2023 18:49:30 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

To reproduce:

  emacs -Q
  C-h f dictionary-search RET

(almost any other function will do, I think).

This takes a whopping 6.6 sec of CPU on master, vs 2.4 sec on the
emacs-29 branch.  These are both unoptimized builds, but even so,
6.6 seconds of CPU time for looking up a doc string of a function
is too much, I think.

The patch below fixes the problem in a build without
native-compilation, but won't help in a build with native-compilation.
I wonder why comp-function-type-spec is so expensive?

In GNU Emacs 30.0.50 (build 417, i686-pc-mingw32) of 2023-08-12 built on
 HOME-C4E4A596F7
Repository revision: d3dae88e6cc8118c875957ba0347be9599014b34
Repository branch: master
Windowing system distributor 'Microsoft Corp.', version 5.1.2600
System Description: Microsoft Windows XP Service Pack 3 (v5.1.0.2600)

Configured using:
 'configure -C --prefix=/d/usr --with-wide-int
 --enable-checking=yes,glyphs 'CFLAGS=-O0 -gdwarf-4 -g3''

Configured features:
ACL GIF GMP GNUTLS HARFBUZZ JPEG JSON LCMS2 LIBXML2 MODULES NOTIFY
W32NOTIFY PDUMPER PNG RSVG SOUND SQLITE3 THREADS TIFF
TOOLKIT_SCROLL_BARS TREE_SITTER WEBP XPM ZLIB

Important settings:
  value of $LANG: ENU
  locale-coding-system: cp1255

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  show-paren-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  line-number-mode: t
  indent-tabs-mode: t
  transient-mark-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message mailcap yank-media puny dired
dired-loaddefs rfc822 mml mml-sec password-cache epa derived epg rfc6068
epg-config gnus-util text-property-search time-date subr-x mm-decode
mm-bodies mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader
cl-loaddefs cl-lib sendmail rfc2047 rfc2045 ietf-drums mm-util
mail-prsvr mail-utils rmc iso-transl tooltip cconv eldoc paren electric
uniquify ediff-hook vc-hooks lisp-float-type elisp-mode mwheel dos-w32
ls-lisp disp-table term/w32-win w32-win w32-vars term/common-win
touch-screen tool-bar dnd fontset image regexp-opt fringe tabulated-list
replace newcomment text-mode lisp-mode prog-mode register page tab-bar
menu-bar rfn-eshadow isearch easymenu timer select scroll-bar mouse
jit-lock font-lock syntax font-core term/tty-colors frame minibuffer
nadvice seq simple cl-generic indonesian philippine cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite emoji-zwj charscript charprop
case-table epa-hook jka-cmpr-hook help abbrev obarray oclosure
cl-preloaded button loaddefs theme-loaddefs faces cus-face macroexp
files window text-properties overlay sha1 md5 base64 format env
code-pages mule custom widget keymap hashtable-print-readable backquote
threads w32notify w32 lcms2 multi-tty move-toolbar make-network-process
emacs)

Memory information:
((conses 16 42844 17019) (symbols 48 6336 0) (strings 16 16702 3269)
 (string-bytes 1 401689) (vectors 16 9351)
 (vector-slots 8 147820 16098) (floats 8 23 25) (intervals 40 276 95)
 (buffers 896 10))

Here's the patch I promised:

diff --git a/lisp/help-fns.el b/lisp/help-fns.el
index fc8f431..bedc5a9 100644
--- a/lisp/help-fns.el
+++ b/lisp/help-fns.el
@@ -715,7 +715,8 @@ help-fns--signature
           (unless (and (symbolp function)
                        (get function 'reader-construct))
             (insert high-usage "\n")
-            (when-let* ((res (comp-function-type-spec function))
+            (when-let* ((res (and (native-comp-available-p)
+                                  (comp-function-type-spec function)))
                         (type-spec (car res))
                         (kind (cdr res)))
               (insert (format